<script setup lang="ts">
import { RouterLink } from 'vue-router'
import type Product from '@/models/Product'
import { computed, ref } from 'vue'
import type Size from '@/models/Size'
import { useCartStore } from '@/stores/cart'

const props = defineProps<{
  item: Product
}>()

const cartStore = useCartStore()

const { addToCart } = cartStore

const hasDiscount = computed(() => props.item.discount > 0)

const firstSize = computed(() => props.item.sizes[0])
const activeSize = ref(firstSize.value)
const activeClass = (currentSizeId: number) => activeSize.value.id === currentSizeId ? 'active' : ''

const oldPrice = computed(() => activeSize.value.price)
const price = computed(() => {
  const price = activeSize.value.price - activeSize.value.price * (props.item.discount / 100)
  return price.toFixed(0)
})

const onSizeChange = (size: Size) => {
  activeSize.value = size
}

const onAddToCart = () => {
  addToCart({
    ...props.item,
    count: 1,
    selectedSize: activeSize.value
  })
}

</script>

<template>
  <div class="col-xl-3 col-lg-4 col-sm-6 col-12 mb--30">
    <div class="axil-product product-style-one">
      <div class="thumbnail">
        <RouterLink :to="{ name: 'single-product', params: { category: item.category.slug, product: item.slug } }">
          <img :src="item.image" alt="Product Images">
        </RouterLink>
        <div v-if="hasDiscount" class="label-block label-right">
          <div class="product-badget">{{item.discount}}% OFF</div>
        </div>
        <div class="product-hover-action">
          <ul class="cart-action">
            <li class="wishlist">
              <a href="wishlist.html">
                <i class="far fa-heart"></i>
              </a>
            </li>
            <li class="select-option">
              <button @click.stop.prevent="onAddToCart">Add to Cart</button>
            </li>
            <li class="quickview">
              <a href="#" data-bs-toggle="modal" data-bs-target="#quick-view-modal">
                <i class="far fa-eye"></i>
              </a>
            </li>
          </ul>
        </div>
      </div>
      <div class="product-content">
        <div class="inner">
          <h5 class="title">
            <RouterLink :to="{ name: 'single-product', params: { category: item.category.slug, product: item.slug } }">
              {{ item.title }}
            </RouterLink>
          </h5>
          <div class="product-price-variant">
            <span v-if="hasDiscount" class="price old-price">${{ oldPrice }}</span>
            <span class="price current-price">${{ price }}</span>
          </div>
          <div class="color-variant-wrapper">
            <ul class="range-variant">
              <li
                  v-for="size of item.sizes"
                  :key="size.id"
                  :class="activeClass(size.id)"
                  @click.stop.prevent="onSizeChange(size)"
              >
                {{size.title}}
              </li>
            </ul>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>